質問をすることでしか得られない、回答やアドバイスがある。

15分調べてもわからないことは、質問しよう!

ただいまの
回答率

89.55%

Sassをgulpで自動コンパイルしたい

解決済

回答 1

投稿 編集

  • 評価
  • クリップ 0
  • VIEW 1,133

yesman

score 11

Sassをgulpで自動コンパイルしようと思っているのですが
コマンドプロクトルでgulp sass:watchで入力して監視させたいのですが
エラー文がでて、できません
何か間違っているのでしょうか?
ご確認お願い致します。

コマンドプロンプト
C:\Users\yesma\Desktop\test_project> gulp sass:watch
[00:30:48] Using gulpfile ~\Desktop\test_project\gulpfile.js
[00:30:48] Starting 'sass:watch'...
[00:30:48] 'sass:watch' errored after 3.68 ms
[00:30:48] Error: watching ./sass/**/*.scss: watch task has to be a function (optionally generated by using gulp.parallel or gulp.series)
    at Gulp.watch (C:\Users\yesma\Desktop\test_project\node_modules\gulp\index.js:28:11)
    at C:\Users\yesma\Desktop\test_project\gulpfile.js:11:8
    at taskWrapper (C:\Users\yesma\Desktop\test_project\node_modules\undertaker\lib\set-task.js:13:15)
    at bound (domain.js:395:14)
    at runBound (domain.js:408:12)
    at asyncRunner (C:\Users\yesma\Desktop\test_project\node_modules\async-done\index.js:55:18)
    at process._tickCallback (internal/process/next_tick.js:61:11)
package.json
{
  "name": "test_project",
  "version": "1.0.0",
  "description": "",
  "main": "index.js",
  "scripts": {
    "test": "echo \"Error: no test specified\" && exit 1"
  },
  "keywords": [],
  "author": "",
  "license": "ISC",
  "devDependencies": {
    "autoprefixer": "^9.4.7",
    "css-mqpacker": "^7.0.0",
    "gulp": "^4.0.0",
    "gulp-sass": "^4.0.2",
    "gulp-sass-glob": "^1.0.9",
    "gulp-sourcemaps": "^2.6.4"
  }
}
gulpfile.js
'use strict';

var gulp = require('gulp');
var sass = require('gulp-sass');
var sassGlob = require('gulp-sass-glob');//①「gulp-sass-glob」を読み込み
var sourcemaps = require('gulp-sourcemaps');//「gulp-sourcemaps」を読み込み
var autoprefixer = require('autoprefixer');//「autoprefixer」を読み込み
var mqpacker = require('css-mqpacker');//①「css-mqpacker」を読み込み
sass.compiler = require('node-sass');

gulp.task('sass', function () {
  return gulp.src('./sass/**/*.scss')
    .pipe(sourcemaps.init())//②「gulp.src」の直後に指定
    .pipe(sassGlob())//②「sass」の前に指定
    .pipe(sass().on('error', sass.logError))
    .pipe(sass({outputStyle: 'expanded'}))
    .pipe(postcss([mqpacker()]))//②「sass」の後に指定
    .pipe(postcss([autoprefixer()]))//②「sass」の後に指定
    .pipe(sourcemaps.write())//③「gulp.dest」の直後に指定
    .pipe(gulp.dest('./css'));
});

gulp.task('sass:watch', function () {
  gulp.watch('./sass/**/*.scss', ['sass']);
});


イメージ説明

  • 気になる質問をクリップする

    クリップした質問は、後からいつでもマイページで確認できます。

    またクリップした質問に回答があった際、通知やメールを受け取ることができます。

    クリップを取り消します

  • 良い質問の評価を上げる

    以下のような質問は評価を上げましょう

    • 質問内容が明確
    • 自分も答えを知りたい
    • 質問者以外のユーザにも役立つ

    評価が高い質問は、TOPページの「注目」タブのフィードに表示されやすくなります。

    質問の評価を上げたことを取り消します

  • 評価を下げられる数の上限に達しました

    評価を下げることができません

    • 1日5回まで評価を下げられます
    • 1日に1ユーザに対して2回まで評価を下げられます

    質問の評価を下げる

    teratailでは下記のような質問を「具体的に困っていることがない質問」、「サイトポリシーに違反する質問」と定義し、推奨していません。

    • プログラミングに関係のない質問
    • やってほしいことだけを記載した丸投げの質問
    • 問題・課題が含まれていない質問
    • 意図的に内容が抹消された質問
    • 過去に投稿した質問と同じ内容の質問
    • 広告と受け取られるような投稿

    評価が下がると、TOPページの「アクティブ」「注目」タブのフィードに表示されにくくなります。

    質問の評価を下げたことを取り消します

    この機能は開放されていません

    評価を下げる条件を満たしてません

    評価を下げる理由を選択してください

    詳細な説明はこちら

    上記に当てはまらず、質問内容が明確になっていない質問には「情報の追加・修正依頼」機能からコメントをしてください。

    質問の評価を下げる機能の利用条件

    この機能を利用するためには、以下の事項を行う必要があります。

質問への追記・修正、ベストアンサー選択の依頼

  • miyabi_takatsuk

    2019/02/20 14:32

    gulpfile.jsを含めた、ディレクトリ構造も、画像でいいので質問に含めてください。
    あと、:などのメタ文字って、関数名とかに含めない方がいいですよ。
    (エラーの原因になりますので)

    キャンセル

  • yesman

    2019/02/20 20:50

    ご連絡ありがとうございます。
    すいません。:などのメタ文字の事ですが、どの箇所を指しているか教えていただけないでしょうか?

    キャンセル

回答 1

checkベストアンサー

+3

回答の準備

まず、以下のようなディレクトリ構造を作成し、

test_project
├ node_modules
├ sass
│ ├ reset
│ │ └ _reset.scss
│ └ style.scss
├ gulpfile.js
└ package.json

package.jsonを以下のように、

{
  "name": "test_project",
  "version": "1.0.0",
  "description": "",
  "main": "index.js",
  "scripts": {
    "test": "echo \"Error: no test specified\" && exit 1"
  },
  "keywords": [],
  "author": "",
  "license": "ISC",
  "devDependencies": {
    "autoprefixer": "^9.4.7",
    "css-mqpacker": "^7.0.0",
    "gulp": "^4.0.0",
    "gulp-postcss": "^8.0.0",
    "gulp-sass": "^4.0.2",
    "gulp-sass-glob": "^1.0.9",
    "gulp-sourcemaps": "^2.6.4"
  },
  "dependencies": {}
}

gulpfile.jsを以下のように、

'use strict';

var gulp = require('gulp');
var sass = require('gulp-sass');
var sassGlob = require('gulp-sass-glob');//①「gulp-sass-glob」を読み込み
var sourcemaps = require('gulp-sourcemaps');//「gulp-sourcemaps」を読み込み
var autoprefixer = require('autoprefixer');//「autoprefixer」を読み込み
var mqpacker = require('css-mqpacker');//①「css-mqpacker」を読み込み
sass.compiler = require('node-sass');

gulp.task('sass', function () {
  return gulp.src('./sass/**/*.scss')
    .pipe(sourcemaps.init())//②「gulp.src」の直後に指定
    .pipe(sassGlob())//②「sass」の前に指定
    .pipe(sass().on('error', sass.logError))
    .pipe(sass({outputStyle: 'expanded'}))
    .pipe(postcss([mqpacker()]))//②「sass」の後に指定
    .pipe(postcss([autoprefixer()]))//②「sass」の後に指定
    .pipe(sourcemaps.write())//③「gulp.dest」の直後に指定
    .pipe(gulp.dest('./css'));
});

gulp.task('sass:watch', function () {
  gulp.watch('./sass/**/*.scss', ['sass']);
});

./sass/style.scssを以下のように、

@import './reset/reset';

body {
  font: 100% Helvetica, sans-serif;
  background-color: #efefef;
}

./sass/reset/reset.scssを以下のようにしました。

html,
body,
ul,
ol {
  margin:  0;
  padding: 0;
}

ここで、sass:watchタスクを実行すると、以下のようにエラーが再現しました。

C:\Users\s8_chu\Desktop\test_project>npx gulp sass:watch
[21:19:50] Using gulpfile ~\Desktop\test_project\gulpfile.js
[21:19:50] Starting 'sass:watch'...
[21:19:50] 'sass:watch' errored after 2.47 ms
[21:19:50] Error: watching ./sass/**/*.scss: watch task has to be a function (optionally generated by using gulp.parallel or gulp.series)
    at Gulp.watch (C:\Users\s8_chu\Desktop\test_project\node_modules\gulp\index.js:28:11)
    at C:\Users\s8_chu\Desktop\test_project\gulpfile.js:25:8
    at taskWrapper (C:\Users\s8_chu\Desktop\test_project\node_modules\undertaker\lib\set-task.js:13:15)
    at bound (domain.js:396:14)
    at runBound (domain.js:409:12)
    at asyncRunner (C:\Users\s8_chu\Desktop\test_project\node_modules\async-done\index.js:55:18)
    at process._tickCallback (internal/process/next_tick.js:61:11)

回答

上記のエラー文に書かれているとおり、gulp 4.x からは、gulp.watchの取る引数が変更されました
これにより、gulp.watchに設定している引数の値が gulp に理解できない状態になっていることが、今回のエラーの原因です。 gulp の API ドキュメントを読むと、gulp 4.x からは、gulp.watch(globs[, opts][, fn])のように引数を取ることがわかります。
gulp 3.9.1 の場合

gulp.watch(glob [, opts], tasks) or gulp.watch(glob [, opts, cb])
Watch files and do something when a file changes. This always returns an EventEmitter that emits change events.

参考: gulp/API.md at v3.9.1 · gulpjs/gulp · GitHub

gulp 4.0.0 の場合

gulp.watch(globs[, opts][, fn])
Takes a path string, an array of path strings, a glob string or an array of glob strings as globs to watch on the filesystem. Also optionally takes options to configure the watcher and a fn to execute when a file changes.

参考: gulp/API.md at v4.0.0 · gulpjs/gulp · GitHub

そのため、今回の質問文のコードを以下のように変更することで、

'use strict';

var gulp = require('gulp');
var sass = require('gulp-sass');
var sassGlob = require('gulp-sass-glob');
var sourcemaps = require('gulp-sourcemaps');
var autoprefixer = require('autoprefixer');
var mqpacker = require('css-mqpacker');
var postcss = require('gulp-postcss');
sass.compiler = require('node-sass');

gulp.task('sass', function () {
  return gulp.src('./sass/**/*.scss')
    .pipe(sourcemaps.init())
    .pipe(sassGlob())
    .pipe(sass().on('error', sass.logError))
    .pipe(sass({outputStyle: 'expanded'}))
    .pipe(postcss([mqpacker()]))
    .pipe(postcss([autoprefixer()]))
    .pipe(sourcemaps.write())
    .pipe(gulp.dest('./css'));
});

gulp.task('sass:watch', function () {
  gulp.watch('./sass/**/*.scss', gulp.series('sass')); // 変更
});

gulp:watchタスクがエラーなく行えるようになると思います。

C:\Users\s8_chu\Desktop\test_project>npx gulp sass:watch
[21:29:19] Using gulpfile ~\Desktop\test_project\gulpfile.js
[21:29:19] Starting 'sass:watch'...
[21:30:37] Starting 'sass'...
[21:30:37] Finished 'sass' after 120 ms

また、質問文のpackage.jsonの場合、sassタスクを実行するためにgulp-postcssパッケージをインストールしておく必要があると思います。

npm i -D gulp-postcss

投稿

編集

  • 回答の評価を上げる

    以下のような回答は評価を上げましょう

    • 正しい回答
    • わかりやすい回答
    • ためになる回答

    評価が高い回答ほどページの上位に表示されます。

  • 回答の評価を下げる

    下記のような回答は推奨されていません。

    • 間違っている回答
    • 質問の回答になっていない投稿
    • スパムや攻撃的な表現を用いた投稿

    評価を下げる際はその理由を明確に伝え、適切な回答に修正してもらいましょう。

  • 2019/02/20 23:44

    ありがとうございます。
    postcssをインストールして試してみたらできました!
    分かりやすい解説もあり、すごい勉強になりました。

    キャンセル

15分調べてもわからないことは、teratailで質問しよう!

  • ただいまの回答率 89.55%
  • 質問をまとめることで、思考を整理して素早く解決
  • テンプレート機能で、簡単に質問をまとめられる

同じタグがついた質問を見る